#! /bin/sh
 
# Definitionen
##D="-D __DEBUG -D __LANG_EN"
##D="-D __LANG_EN"
D="-D __LANG_DE"
OPT="-O a"
##OPT=""

# Pfade
bin="../Bin"
##bin="/home/ftp/hive"
sd="${bin}/sdcard"
sdsys="${bin}/sdcard/system"
flash="${bin}/flash"
libpath="lib"
BSTC="bstc"
##BSTC="../open-source-spin-compiler-read-only/openspin"

# ----------------------------------------------------------------
# Alte Versionen löschen

rm -rf ${bin}
mkdir -p ${sdsys}
mkdir ${flash}

# ----------------------------------------------------------------
# Flashdateien erzeugen
# --> bin/flash

${BSTC} -L ${libpath} ${D} -D __ADM_FAT -D __ADM_HSS -D __ADM_HSS_PLAY -D __ADM_WAV -D __ADM_RTC -D __ADM_COM -b ${OPT} -o flash/administra/admflash.binary flash/administra/admflash.spin
cp flash/administra/admflash.binary ${flash}
mv flash/administra/admflash.binary ${sdsys}/admsys.adm

${BSTC} -L ${libpath} ${D} -D __VGA -b ${OPT} -o flash/bellatrix/belflash.binary flash/bellatrix/belflash.spin
cp flash/bellatrix/belflash.binary ${flash}
mv flash/bellatrix/belflash.binary ${sdsys}/vga.bel

${BSTC} -L ${libpath} ${D} -D __TV -b ${OPT} -o flash/bellatrix/belflash.binary flash/bellatrix/belflash.spin
mv flash/bellatrix/belflash.binary ${sdsys}/tv.bel

${BSTC} -L ${libpath} ${D} -D regime -b ${OPT} -o flash/regnatix/regflash.binary flash/regnatix/regflash.spin
mv flash/regnatix/regflash.binary ${flash}

${BSTC} -L ${libpath} ${D} -D forth -b ${OPT} -o flash/regnatix/regflash.binary flash/regnatix/regflash.spin
mv  flash/regnatix/regflash.binary ${flash}/regforth.binary

# ----------------------------------------------------------------
# Startdateie erzeugen
# reg.sys	(Regime)
# --> bin/sdcard\

${BSTC} -L ${libpath} ${D} -b ${OPT} -o system/regnatix/regime.binary system/regnatix/regime.spin
mv system/regnatix/regime.binary ${sd}/reg.sys

# ----------------------------------------------------------------
# Slave-Dateien erzeugen
# admsid, admay, admnet
# htxt, g0key

${BSTC} -L ${libpath} ${D} -D __ADM_FAT -D __ADM_SID -b ${OPT} -o flash/administra/admflash.binary flash/administra/admflash.spin
mv flash/administra/admflash.binary ${sdsys}/admsid.adm
${BSTC} -L ${libpath} ${D} -D __ADM_FAT -D __ADM_AYS -b ${OPT} -o flash/administra/admflash.binary flash/administra/admflash.spin
mv flash/administra/admflash.binary ${sdsys}/admay.adm
${BSTC} -L ${libpath} ${D} -D __ADM_FAT -D __ADM_HSS -D __ADM_LAN -D __ADM_RTC -D __ADM_COM -b ${OPT} -o flash/administra/admflash.binary flash/administra/admflash.spin
mv flash/administra/admflash.binary ${sdsys}/admnet.adm

${BSTC} -L ${libpath} ${D} -b ${OPT} -o system/bellatrix/bel-htext/htext.binary system/bellatrix/bel-htext/htext.spin
mv system/bellatrix/bel-htext/htext.binary ${sdsys}/htext.bel
${BSTC} -L ${libpath} ${D} -b ${OPT} -o  system/bellatrix/bel-g0/g0key.binary system/bellatrix/bel-g0/g0key.spin
mv  system/bellatrix/bel-g0/g0key.binary ${sdsys}/g0key.bel

# ----------------------------------------------------------------
# Systemdateien erzeugen
# - div. externe Kommandos
# - div. Systemdateien (Farbtabellen usw.)
# --> bin/sdcard/system/

for FILE in system/regnatix/*.spin ; do 
    ${BSTC} -L ${libpath} ${D} -b ${OPT} ${FILE}
    BASE="`basename ${FILE} .spin`"
    mv "${BASE}.binary" "${sdsys}/${BASE}.bin"
done
cp forth/* ${sdsys}
cp system/sonstiges/* ${sdsys}
